/*
 * ControlUnit.c
 *
 * Created: 11.02.2013 16:32:04
 *  Author: Julian
 */ 

#define F_CPU 16000000

#include <avr/interrupt.h>
#include <avr/io.h>
#include <util/delay.h>

#define STATUS_TOG	PORTD ^= (1<<PIND2)

#include "rs232_init.h"

void send_all_DMX(void);

int main(void)
{
	// INIT START
	USARTInit();	//init
	DDRD = (1<<PIND1) | (1<<PIND2); // TX - Ausgang, Status LED
	
	while(1)
	{
		STATUS_TOG;
		send_all_DMX();
		_delay_ms(50);
    }
}

void send_all_DMX(void)
{
		UCSR0B &= ~(1<<TXEN0);	//disable Tx
		PORTD &= ~(1<<1);	//88us RESET
		_delay_us(88);
		PORTD |= (1<<1);	//8us MARK
		_delay_us(8);
		UCSR0B = (1<<TXEN0);	//enable Tx
		sendDMX();		//send data
		UCSR0B &= ~(1<<TXEN0);	//disable Tx
		PORTD |= (1<<1);	//8us MARK
		_delay_us(8);
}