/*
 * rs232_init.c
 *
 * Created: 12.02.2013 14:18:44
 *  Author: Nico
 */ 

#include <avr/interrupt.h>
#include <avr/io.h>
#include "rs232_init.h"

volatile char DMXData[512];

//initialize the USART
void USARTInit(void)
{
	UBRR0 = 7; // 250 kbs bei 16 mhz
	
	UCSR0A = 0x00;
	UCSR0B = 0x00;
	UCSR0C = 0x00;
 	
	UCSR0A = (1<<U2X0);	//double speed operation
	UCSR0B = (1<<UCSZ02) | (1<<TXEN0);
	UCSR0C = (1<<USBS0) | (1<<UCSZ01) | (1<<UCSZ00);
}

//sende einzelnen char
void USARTWriteChar(unsigned char rx_data)
{
   //Wait untill the transmitter is ready

   while(!(UCSR0A & (1<<UDRE0)))
   {	/*Do nothing*/	}

   //Now write the data to USART buffer
   UDR0=rx_data;
}


// sende ein Array von Chars
void sende (const char *s)
{
    do
    {
        USARTWriteChar(*s);
    }
    while (*s++);
}

void sendDMX(void)
{
	volatile int i;
	
	// Setzt alle Werte auf 0x00
	for(i=0;i<512;i++)
	{
		DMXData[i] = 0x00;
	}
	
	USARTWriteChar(0);

	for(i = 0; i<512; i++)
	{
		volatile char forDebug = DMXData[i];
		
		//DMXData[i] = 0x00; // Wenn diese Zeile einkommentiert ist gibt er 0x00 aus anderfalls 0xFF (oder irgendwas willkrliches)
		
		USARTWriteChar(DMXData[i]);
		//USARTWriteChar(0x00); // Mit dieser Zeile wird 0x00 ausgegeben

	}
}